## mapserver 8.2.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0...3.29)

project (MapServer)

if("${PROJECT_SOURCE_DIR}" STREQUAL "${PROJECT_BINARY_DIR}")
      message(FATAL_ERROR "In-source builds are not permitted. Make a separate folder for building:
   mkdir build; cd build; cmake ..
Before that, remove the files created by this failed run:
   rm -rf CMakeCache.txt CMakeFiles")
endif("${PROJECT_SOURCE_DIR}" STREQUAL "${PROJECT_BINARY_DIR}")

include(CheckLibraryExists)
include(CheckFunctionExists)
include(CheckSymbolExists)
include(CheckIncludeFile)
include(CheckCSourceCompiles)

set (MapServer_VERSION_MAJOR 8)
set (MapServer_VERSION_MINOR 2)
set (MapServer_VERSION_REVISION 1)
set (MapServer_VERSION_SUFFIX "")

# Set C++ version
# Make CMAKE_CXX_STANDARD available as cache option overridable by user
set(CMAKE_CXX_STANDARD 11
  CACHE STRING "C++ standard version to use (default is 11)")
message(STATUS "Requiring C++${CMAKE_CXX_STANDARD}")
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)
message(STATUS "Requiring C++${CMAKE_CXX_STANDARD} - done")

# Set C99 version
# Make CMAKE_C_STANDARD available as cache option overridable by user
set(CMAKE_C_STANDARD 99
  CACHE STRING "C standard version to use (default is 99)")
message(STATUS "Requiring C${CMAKE_C_STANDARD}")
set(CMAKE_C_STANDARD_REQUIRED ON)
set(CMAKE_C_EXTENSIONS OFF)
message(STATUS "Requiring C${CMAKE_C_STANDARD} - done")

set(TARGET_VERSION_MAJOR ${MapServer_VERSION_MAJOR})
set(TARGET_VERSION_MINOR ${MapServer_VERSION_MINOR})

MATH(EXPR MapServer_IS_DEV_VERSION "${MapServer_VERSION_MINOR}%2")
if(MapServer_IS_DEV_VERSION)
  set (MapServer_VERSION_STRING "${MapServer_VERSION_MAJOR}.${MapServer_VERSION_MINOR}-dev")
else(MapServer_IS_DEV_VERSION)
  set (MapServer_VERSION_STRING "${MapServer_VERSION_MAJOR}.${MapServer_VERSION_MINOR}.${MapServer_VERSION_REVISION}")
  set (MapServer_VERSION_STRING "${MapServer_VERSION_STRING}${MapServer_VERSION_SUFFIX}")
endif(MapServer_IS_DEV_VERSION)
MATH(EXPR MapServer_VERSION_NUM "${MapServer_VERSION_MAJOR}*10000+${MapServer_VERSION_MINOR}*100+${MapServer_VERSION_REVISION}")

SET(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake ${CMAKE_MODULE_PATH})
foreach(_version IN ITEMS 3.20)
    if(CMAKE_VERSION VERSION_LESS "${_version}")
        list(INSERT CMAKE_MODULE_PATH 0 "${PROJECT_SOURCE_DIR}/cmake/${_version}")
    endif()
endforeach()

if (APPLE)
  set(CMAKE_FIND_FRAMEWORK "LAST")
endif (APPLE)

# Offer the user the choice of overriding the installation directories
set(INSTALL_LIB_DIR lib CACHE PATH "Installation directory for libraries")
set(INSTALL_BIN_DIR bin CACHE PATH "Installation directory for executables")
set(INSTALL_INCLUDE_DIR include CACHE PATH "Installation directory for header files")
if(WIN32 AND NOT CYGWIN)
  set(DEF_INSTALL_CMAKE_DIR CMake)
else()
  set(DEF_INSTALL_CMAKE_DIR share/mapserver/cmake)
endif()
set(INSTALL_CMAKE_DIR ${DEF_INSTALL_CMAKE_DIR} CACHE PATH "Installation directory for CMake files")

# Make relative paths absolute (needed later on)
foreach(p LIB BIN INCLUDE CMAKE)
  set(var INSTALL_${p}_DIR)
  if(NOT IS_ABSOLUTE "${${var}}")
    set(${var} "${CMAKE_INSTALL_PREFIX}/${${var}}")
  endif()
endforeach()

macro (ms_link_libraries)
  if(BUILD_DYNAMIC)
    target_link_libraries(mapserver ${ARGV})
  endif(BUILD_DYNAMIC)
  if(BUILD_STATIC)
    target_link_libraries(mapserver_static ${ARGV})
  endif(BUILD_STATIC)
endmacro()

macro( report_optional_not_found component )
  message(SEND_ERROR "${component} library/component/dependency could not be found.
  HINTS:
  - disable ${component} support by adding -DWITH_${component}=0
  - add the ${component} install directory to the CMAKE_PREFIX_PATH variable (-DCMAKE_PREFIX_PATH=\"/path/to/${component}-install-dir;/path/to/other/dirs\"")
endmacro()
macro( report_mandatory_not_found component )
  message(SEND_ERROR "${component} library/component could not be found and is a mandatory dependency
  HINT:
  - add the ${component} install directory to the CMAKE_PREFIX_PATH variable (-DCMAKE_PREFIX_PATH=\"/path/to/${component}-install-dir;/path/to/other/dirs\"")
endmacro()
macro( report_dependency_error component dependency)
  message(SEND_ERROR "${component} support requires ${dependency} support, however ${dependency} support has been disabled.
  HINTS:
  - re-run with -DWITH_${dependency}=1 (or without -DWITH_${dependency}=0)
  - disable ${component} support by adding -DWITH_${component}=0"
  )
endmacro()

SET(CMAKE_REQUIRED_INCLUDES "math.h")
if(NOT(WIN32))
SET(CMAKE_REQUIRED_LIBRARIES "m")
endif(NOT(WIN32))

check_function_exists("strrstr"          HAVE_STRRSTR)
check_function_exists("strcasecmp"  HAVE_STRCASECMP)
check_function_exists("strcasestr"  HAVE_STRCASESTR)
check_function_exists("strlcat"  HAVE_STRLCAT)
check_function_exists("strlcpy"  HAVE_STRLCPY)
check_function_exists("strlen"  HAVE_STRLEN)
check_function_exists("strncasecmp"  HAVE_STRNCASECMP)

IF((HAVE_STRLCAT OR HAVE_STRLCPY) AND CMAKE_SYSTEM_NAME MATCHES "Linux")
    add_definitions(-D_DEFAULT_SOURCE)
ENDIF()

check_symbol_exists(vsnprintf stdio.h HAVE_VSNPRINTF)
IF(NOT HAVE_VSNPRINTF)
    check_function_exists("vsnprintf"  HAVE_VSNPRINTF)
ENDIF()

check_function_exists("lrintf" HAVE_LRINTF)
check_function_exists("lrint" HAVE_LRINT)

check_include_file(dlfcn.h HAVE_DLFCN_H)


check_c_source_compiles("
int main(int argc, char **argv) {
   long x=0,y=0;
   for(x=0;x<5;x++) {
     if(y>1) break;
     y=__sync_fetch_and_add(&x,1);
   }
}" HAVE_SYNC_FETCH_AND_ADD)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

#options suported by the cmake builder
option(WITH_PROTOBUFC "Choose if protocol buffers support should be built in (required for vector tiles)" ON)
option(WITH_KML "Enable native KML output support (requires libxml2 support)" OFF)
option(WITH_SOS "Enable SOS Server support (requires PROJ and libxml2 support)" OFF)
option(WITH_WMS "Enable WMS Server support (requires PROJ support)" ON)
option(WITH_FRIBIDI "Choose if FriBidi glyph shaping support should be built in (usefull for right-to-left languages) (requires HARFBUZZ)" ON)
option(WITH_HARFBUZZ "Choose if Harfbuzz complex text layout should be included (needed for e.g. arabic and hindi) (requires FRIBIDI)" ON)
option(WITH_ICONV "Choose if Iconv Internationalization support should be built in" ON)
option(WITH_CAIRO "Choose if CAIRO  rendering support should be built in (required for SVG and PDF output)" ON)
option(WITH_SVGCAIRO "Choose if SVG symbology support (via libsvgcairo) should be built in (requires cairo, libsvg, libsvg-cairo. Incompatible with librsvg)" OFF)
option(WITH_RSVG "Choose if SVG symbology support (via librsvg) should be built in (requires cairo, librsvg. Incompatible with libsvg-cairo)" OFF)
option(WITH_MYSQL "Choose if MYSQL joining support should be built in" OFF)
option(WITH_FCGI "Choose if FastCGI support should be built in" ON)
option(WITH_GEOS "Choose if GEOS geometry operations support should be built in" ON)
option(WITH_POSTGIS "Choose if Postgis input support should be built in" ON)
option(WITH_CLIENT_WMS "Enable Client WMS Layer support (requires CURL)" OFF)
option(WITH_CLIENT_WFS "Enable Client WMS Layer support (requires CURL)" OFF)
option(WITH_CURL "Enable Curl HTTP support (required for wms/wfs client, and remote SLD)" OFF)
option(WITH_WFS "Enable WFS Server support (requires PROJ and OGR support)" ON)
option(WITH_WCS "Enable WCS Server support (requires PROJ and GDAL support)" ON)
option(WITH_OGCAPI "Enable OGCAPI Server support (requires PROJ and OGR support)" ON)
option(WITH_LIBXML2 "Choose if libxml2 support should be built in (used for sos, wcs 1.1,2.0 and wfs 1.1)" ON)
option(WITH_THREAD_SAFETY "Choose if a thread-safe version of libmapserver should be built (only recommended for some mapscripts)" OFF)
option(WITH_GIF "Enable GIF support (for PIXMAP loading)" ON)
option(WITH_PYTHON "Enable Python mapscript support" OFF)
option(WITH_PHPNG "Enable PHPNG (SWIG) mapscript support" OFF)
option(WITH_PERL "Enable Perl mapscript support" OFF)
option(WITH_RUBY "Enable Ruby mapscript support" OFF)
option(WITH_JAVA "Enable Java mapscript support" OFF)
option(WITH_CSHARP "Enable C# mapscript support" OFF)
option(WITH_ORACLESPATIAL "include oracle spatial database input support" OFF)
option(WITH_ORACLE_PLUGIN "include oracle spatial database input support as plugin" OFF)
option(WITH_MSSQL2008 "include mssql 2008 database input support as plugin" OFF)
option(WITH_EXEMPI "include xmp output metadata support" OFF)
option(WITH_XMLMAPFILE "include native xml mapfile support (requires libxslt/libexslt)" OFF)
option(WITH_V8 "include javacript v8 scripting" OFF)
option(WITH_PIXMAN "use (experimental) support for pixman for layer compositing operations" OFF)

option(BUILD_STATIC "Also build a static version of mapserver" OFF)
option(LINK_STATIC_LIBMAPSERVER "Link to static version of libmapserver (also for mapscripts)" OFF)
option(WITH_APACHE_MODULE "include (experimental) support for apache module" OFF)
option(WITH_GENERIC_NINT "generic rounding" OFF)
option(WITH_PYMAPSCRIPT_ANNOTATIONS "Add annotations to Python mapscript output" OFF)

option(FUZZER "Build fuzzers using libFuzzer (requires Clang, will disable executable - mapserv, etc. - generation)" OFF)
mark_as_advanced(FUZZER)
option(BUILD_FUZZER_REPRODUCER "Build fuzzer reproducer programs" ON)

if(FUZZER AND BUILD_FUZZER_REPRODUCER)
    message(FATAL_ERROR "FUZZER and BUILD_FUZZER_REPRODUCER options are mutually exclusive")
endif()

#TODO: USE_OGL? , USE_SDE, USE_CLUSTER_EXTERNAL USE_CLUSTER_PLUGIN, USE_MSSQL2008, USE_MSSQL2008_PLUGIN
# SIGNORE_MISSING_DATA, CGI_CL_DEBUG_ARGS, EXTRA DEBUG FLAGS?,
# PERLV_ld_DETECT?

# Add compiler flags for warnings
if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_COMPILER_IS_GNUCC OR CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Werror=format-security")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Werror=format-security")
endif()

if(FUZZER)
    if (NOT CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
        message(FATAL_ERROR "Need clang for libFuzzer support")
    endif()

    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=fuzzer,address -DFUZZING_BUILD_MODE_UNSAFE_FOR_PRODUCTION")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=fuzzer,address -DFUZZING_BUILD_MODE_UNSAFE_FOR_PRODUCTION")
endif()

if(NOT DEFINED CMAKE_INSTALL_LIBDIR)
  set(_LIBDIR_DEFAULT "lib")
  # Override this default 'lib' with 'lib64' iff:
  #  - we are on Linux system but NOT cross-compiling
  #  - we are NOT on debian
  #  - we are on a 64 bits system
  # reason is: amd64 ABI: http://www.x86-64.org/documentation/abi.pdf
  # Note that the future of multi-arch handling may be even
  # more complicated than that: http://wiki.debian.org/Multiarch
  if(CMAKE_SYSTEM_NAME MATCHES "Linux"
      AND NOT CMAKE_CROSSCOMPILING
      AND NOT EXISTS "/etc/debian_version")
    if(NOT DEFINED CMAKE_SIZEOF_VOID_P)
      message(AUTHOR_WARNING
        "Unable to determine default CMAKE_INSTALL_LIBDIR directory because no target architecture is known. "
        "Please enable at least one language before including GNUInstallDirs.")
    else()
      if("${CMAKE_SIZEOF_VOID_P}" EQUAL "8")
        set(_LIBDIR_DEFAULT "lib64")
      endif()
    endif()
  endif()
  set(CMAKE_INSTALL_LIBDIR "${_LIBDIR_DEFAULT}" CACHE PATH "object code libraries (${_LIBDIR_DEFAULT})")
endif()

if(NOT DEFINED CMAKE_INSTALL_RPATH)
  SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
  SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
endif()
SET(CMAKE_MACOSX_RPATH ON)

if(LINK_STATIC_LIBMAPSERVER)
  set(BUILD_STATIC 1)
  set(BUILD_DYNAMIC 0)
  set(MAPSERVER_LIBMAPSERVER mapserver_static)
else(LINK_STATIC_LIBMAPSERVER)
  set(BUILD_DYNAMIC 1)
  set(MAPSERVER_LIBMAPSERVER mapserver)
endif(LINK_STATIC_LIBMAPSERVER)

set(agg_SOURCES
src/renderers/agg/src/agg_arc.cpp
src/renderers/agg/src/agg_vcgen_dash.cpp
src/renderers/agg/src/agg_vcgen_contour.cpp
src/renderers/agg/src/agg_curves.cpp

=== fuzzers/CMakeLists.txt ===
foreach(FUZZER_NAME IN ITEMS shapefuzzer mapfuzzer configfuzzer)
    if(FUZZER)
        add_executable(${FUZZER_NAME} ${FUZZER_NAME}.c)
        target_compile_options(${FUZZER_NAME} PRIVATE -Wall -Wextra -Werror=format-security)
        target_include_directories(${FUZZER_NAME} PRIVATE ${PROJECT_SOURCE_DIR})
        target_link_libraries(${FUZZER_NAME} ${MAPSERVER_LIBMAPSERVER})
    else()
        set(FUZZER_REPRODUCER "${FUZZER_NAME}_reproducer")
        add_executable(${FUZZER_REPRODUCER} ${FUZZER_NAME}.c reproducer_main.cpp)
        target_include_directories(${FUZZER_REPRODUCER} PRIVATE ${PROJECT_SOURCE_DIR})
        target_link_libraries(${FUZZER_REPRODUCER} ${MAPSERVER_LIBMAPSERVER})
    endif()
endforeach()

=== src/mapscript/csharp/CMakeLists.txt ===
FIND_PACKAGE(SWIG REQUIRED)
INCLUDE(${SWIG_USE_FILE})

FIND_PROGRAM (CSHARP_COMPILER NAMES csc mcs gmcs gmcs2)

IF (CSHARP_COMPILER)
	MESSAGE(STATUS "Found CSharp compiler: ${CSHARP_COMPILER}")
ELSE (CSHARP_COMPILER)
	MESSAGE(FATAL_ERROR "Could not find csharp compiler")
ENDIF (CSHARP_COMPILER)

if (WIN32)
  if (NOT MSVC71)
    if (CMAKE_CL_64)
      set(PLATFORM_TARGET /platform:anycpu)
    else(CMAKE_CL_64)
      set(PLATFORM_TARGET /platform:x86)
    endif(CMAKE_CL_64)
	set (KEYFILE_SPEC /keyfile:${PROJECT_SOURCE_DIR}\\src\\mapscript\\csharp\\mapscript.snk)
  endif (NOT MSVC71)
  if (MSVC_VERSION GREATER 1500)
      set(PLATFORM_TARGET ${PLATFORM_TARGET} /define:CLR4)
  endif (MSVC_VERSION GREATER 1500)
  MESSAGE(STATUS "Cmake build type: ${CMAKE_BUILD_TYPE}")
  if (CMAKE_BUILD_TYPE STREQUAL "Debug" OR CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo") 
      set(PLATFORM_TARGET ${PLATFORM_TARGET} /debug:full)
  endif (CMAKE_BUILD_TYPE STREQUAL "Debug" OR CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo")
else()
	set (KEYFILE_SPEC -keyfile:${PROJECT_SOURCE_DIR}/src/mapscript/csharp/mapscript.snk)
endif(WIN32)

MARK_AS_ADVANCED(CSHARP_COMPILER)

include_directories(${PROJECT_SOURCE_DIR}/src/mapscript/swiginc)
include_directories(${PROJECT_SOURCE_DIR}/src/mapscript/)
include_directories(${PROJECT_SOURCE_DIR}/src/mapscript/csharp)
include_directories(${PROJECT_BINARY_DIR}/src/mapscript/)
SET (CMAKE_SWIG_OUTDIR "${CMAKE_CURRENT_BINARY_DIR}")
if (WIN32)
	SET( CMAKE_SWIG_FLAGS -namespace OSGeo.MapServer -DWIN32 ${MAPSERVER_COMPILE_DEFINITIONS})
else()
	SET( CMAKE_SWIG_FLAGS -namespace OSGeo.MapServer ${MAPSERVER_COMPILE_DEFINITIONS})
endif()
if (${CMAKE_VERSION} VERSION_LESS "3.8.0")
	SWIG_ADD_MODULE(mapscript csharp ../mapscript.i)
else()
	SWIG_ADD_LIBRARY(mapscript LANGUAGE csharp SOURCES ../mapscript.i)
endif()

# CMake 3.29.0 corrects an issue with earlier CMake versions regarding the
# shared library name (cf https://gitlab.kitware.com/cmake/cmake/-/issues/25405
# / https://gitlab.kitware.com/cmake/cmake/-/merge_requests/8973)
if (WIN32 OR (${CMAKE_VERSION} VERSION_GREATER_EQUAL "3.29.0"))
	set_target_properties(mapscript PROPERTIES OUTPUT_NAME "mapscript")
else()
	set_target_properties(mapscript PROPERTIES OUTPUT_NAME "libmapscript")
endif()

SWIG_LINK_LIBRARIES(mapscript ${MAPSERVER_LIBMAPSERVER})




if (WIN32)

	ADD_CUSTOM_COMMAND(TARGET mapscript
						  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
						  POST_BUILD
						  COMMAND set MAPSCRIPT_SNK=${PROJECT_SOURCE_DIR}\\src\\mapscript\\csharp\\mapscript.snk
						  COMMAND set MAPSCRIPT_SNK=%MAPSCRIPT_SNK:/=\\%
						  COMMAND copy /Y \"%MAPSCRIPT_SNK%\"
						  COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} /t:library /out:mapscript_csharp.dll ${KEYFILE_SPEC} *.cs ${PROJECT_SOURCE_DIR}\\src\\mapscript\\csharp\\config\\AssemblyInfo.cs
						  COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} /r:mapscript_csharp.dll /out:shpdump.exe ${PROJECT_SOURCE_DIR}\\src\\mapscript\\csharp\\examples\\shpdump.cs
						  COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} /r:mapscript_csharp.dll /out:drawmap.exe ${PROJECT_SOURCE_DIR}\\src\\mapscript\\csharp\\examples\\drawmap.cs
						  COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} /r:mapscript_csharp.dll /out:shapeinfo.exe ${PROJECT_SOURCE_DIR}\\src\\mapscript\\csharp\\examples\\shapeinfo.cs
						  COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} /r:mapscript_csharp.dll /out:drawquery.exe ${PROJECT_SOURCE_DIR}\\src\\mapscript\\csharp\\examples\\drawquery.cs
						  COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} /r:mapscript_csharp.dll /r:System.Drawing.dll /out:getbytes.exe ${PROJECT_SOURCE_DIR}\\src\\mapscript\\csharp\\examples\\getbytes.cs
						  COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} /r:mapscript_csharp.dll /out:HTMLtemplate.exe ${PROJECT_SOURCE_DIR}\\src\\mapscript\\csharp\\examples\\HTMLtemplate.cs
						  COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} /r:mapscript_csharp.dll /out:RFC24.exe ${PROJECT_SOURCE_DIR}\\src\\mapscript\\csharp\\examples\\RFC24.cs
						  COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} /r:mapscript_csharp.dll /r:System.Drawing.dll /out:drawmapDirect.exe ${PROJECT_SOURCE_DIR}\\src\\mapscript\\csharp\\examples\\drawmapDirect.cs
						  COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} /r:mapscript_csharp.dll /r:System.Drawing.dll /out:drawmapDirectPrint.exe ${PROJECT_SOURCE_DIR}\\src\\mapscript\\csharp\\examples\\drawmapDirectPrint.cs
						  COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} /r:mapscript_csharp.dll /r:System.Drawing.dll /out:drawmapGDIPlus.exe ${PROJECT_SOURCE_DIR}\\src\\mapscript\\csharp\\examples\\drawmapGDIPlus.cs
						  #COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} /lib:C:\Windows\Microsoft.NET\Framework\v4.0.30319\WPF /r:mapscript_csharp.dll /r:System.Xaml.dll /r:WindowsBase.dll /r:PresentationCore.dll /out:drawmapWPF.exe ${PROJECT_SOURCE_DIR}\\src\\mapscript\\csharp\\examples\\drawmapWPF.cs
						  COMMENT "Compiling c# source files"
						  )
else()
	ADD_CUSTOM_COMMAND(TARGET mapscript
						WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
						POST_BUILD
						COMMAND cp -f ${PROJECT_SOURCE_DIR}/src/mapscript/csharp/mapscript.snk ./
						COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} -target:library -out:mapscript_csharp.dll ${KEYFILE_SPEC} *.cs ${PROJECT_SOURCE_DIR}/src/mapscript/csharp/config/AssemblyInfo.cs
						COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} -reference:mapscript_csharp.dll -out:shpdump.exe ${PROJECT_SOURCE_DIR}/src/mapscript/csharp/examples/shpdump.cs
						COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} -reference:mapscript_csharp.dll -out:drawmap.exe ${PROJECT_SOURCE_DIR}/src/mapscript/csharp/examples/drawmap.cs
						COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} -reference:mapscript_csharp.dll -out:shapeinfo.exe ${PROJECT_SOURCE_DIR}/src/mapscript/csharp/examples/shapeinfo.cs
						COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} -reference:mapscript_csharp.dll -out:drawquery.exe ${PROJECT_SOURCE_DIR}/src/mapscript/csharp/examples/drawquery.cs
						COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} -reference:mapscript_csharp.dll -reference:System.Drawing.dll -out:getbytes.exe ${PROJECT_SOURCE_DIR}/src/mapscript/csharp/examples/getbytes.cs
						COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} -reference:mapscript_csharp.dll -out:HTMLtemplate.exe ${PROJECT_SOURCE_DIR}/src/mapscript/csharp/examples/HTMLtemplate.cs
						COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} -reference:mapscript_csharp.dll -out:RFC24.exe ${PROJECT_SOURCE_DIR}/src/mapscript/csharp/examples/RFC24.cs
						COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} -reference:mapscript_csharp.dll -reference:System.Drawing.dll -out:drawmapDirect.exe ${PROJECT_SOURCE_DIR}/src/mapscript/csharp/examples/drawmapDirect.cs
						COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} -reference:mapscript_csharp.dll -reference:System.Drawing.dll -out:drawmapDirectPrint.exe ${PROJECT_SOURCE_DIR}/src/mapscript/csharp/examples/drawmapDirectPrint.cs
						COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} -reference:mapscript_csharp.dll -reference:System.Drawing.dll -out:drawmapGDIPlus.exe ${PROJECT_SOURCE_DIR}/src/mapscript/csharp/examples/drawmapGDIPlus.cs
						#COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} /lib:C:\Windows\Microsoft.NET\Framework\v4.0.30319\WPF /r:mapscript_csharp.dll /r:System.Xaml.dll /r:WindowsBase.dll /r:PresentationCore.dll /out:drawmapWPF.exe ${PROJECT_SOURCE_DIR}\\src\\mapscript\\csharp\\examples\\drawmapWPF.cs
						COMMENT "Compiling c# source files"
						)
endif()

=== src/mapscript/python/CMakeLists.txt ===
find_package(SWIG REQUIRED)
include(${SWIG_USE_FILE})

find_package (Python REQUIRED COMPONENTS Interpreter Development)

include_directories(${Python_INCLUDE_DIRS})
include_directories(${PROJECT_SOURCE_DIR}/src/mapscript/swiginc)
include_directories(${PROJECT_SOURCE_DIR}/src/mapscript/)
include_directories(${PROJECT_SOURCE_DIR}/src/mapscript/python)
include_directories(${PROJECT_BINARY_DIR}/src/mapscript/)

set(SwigFile ${PROJECT_SOURCE_DIR}/src/mapscript/mapscript.i)

# add and comments annotations to py file output - requires >= SWIG 4.1
if (WITH_PYMAPSCRIPT_ANNOTATIONS AND ${Python_VERSION_MAJOR} GREATER_EQUAL 3)
  set_property(SOURCE ${SwigFile} APPEND PROPERTY SWIG_FLAGS -doxygen)
  if (${Python_VERSION_MINOR} GREATER_EQUAL 6)
     set_property(SOURCE ${SwigFile} APPEND PROPERTY SWIG_FLAGS -features python:annotations=c)
  else ()
     set_property(SOURCE ${SwigFile} APPEND PROPERTY SWIG_FLAGS -features python:annotations=c,python:annotations:novar)
  endif ()
endif ()

if (${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION} VERSION_GREATER 3.7)
    swig_add_library(pythonmapscript TYPE MODULE LANGUAGE python SOURCES ${SwigFile})
else ()
    swig_add_module(pythonmapscript python ${SwigFile})
endif ()

swig_link_libraries(pythonmapscript ${Python_LIBRARIES} ${MAPSERVER_LIBMAPSERVER})

set_target_properties(${SWIG_MODULE_pythonmapscript_REAL_NAME} PROPERTIES PREFIX "")
set_target_properties(${SWIG_MODULE_pythonmapscript_REAL_NAME} PROPERTIES OUTPUT_NAME _mapscript)

set(SETUP_PY_IN "${PROJECT_SOURCE_DIR}/src/mapscript/python/setup.py.in")
set(SETUP_PY_TEMP "${CMAKE_CURRENT_BINARY_DIR}/setup.py.temp")

configure_file(${SETUP_PY_IN} ${SETUP_PY_TEMP} @ONLY)
file(READ ${SETUP_PY_TEMP} SETUP_CONTENT)

# each target (e.g. Debug, Release etc.) will have a copy of setup.py

file(GENERATE OUTPUT $<TARGET_FILE_DIR:${SWIG_MODULE_pythonmapscript_REAL_NAME}>/setup.py INPUT ${SETUP_PY_TEMP})

if(MSVC)
    set(OUTPUT_FOLDER ${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_BUILD_TYPE})
else()
    # for non-Windows builds there are no build type subfolders (e.g. Release, Debug etc.)
    set(OUTPUT_FOLDER ${CMAKE_CURRENT_BINARY_DIR})
endif()

if(WIN32)
    # Windows venv binaries are in a different location than Linux
    set(Python_VENV_SCRIPTS ${OUTPUT_FOLDER}/mapscriptvenv/Scripts)
else()
    set(Python_VENV_SCRIPTS ${OUTPUT_FOLDER}/mapscriptvenv/bin)
endif()

add_custom_target(
    pythonmapscript-wheel
    DEPENDS mapscripttests.stamp
)

add_custom_command(
    DEPENDS ${SWIG_MODULE_pythonmapscript_REAL_NAME}
    OUTPUT mapscriptvenv.stamp
    WORKING_DIRECTORY ${OUTPUT_FOLDER}
    COMMAND ${Python_EXECUTABLE} -m pip install pip --upgrade
    COMMAND ${Python_EXECUTABLE} -m pip install virtualenv
    COMMAND ${Python_EXECUTABLE} -m virtualenv mapscriptvenv
    COMMAND ${Python_VENV_SCRIPTS}/pip install -r ${PROJECT_SOURCE_DIR}/src/mapscript/python/requirements-dev.txt > requires.log
    COMMENT "Creating a Python virtual environment and installing the required packages"
)

add_custom_command(
    DEPENDS mapscriptvenv.stamp
    OUTPUT mapscriptwheel.stamp
    WORKING_DIRECTORY ${OUTPUT_FOLDER}
    COMMAND ${Python_VENV_SCRIPTS}/python -m build --wheel > wheel_build.log
    COMMENT "Building the mapscript Python wheel"
)

add_custom_command(
    WORKING_DIRECTORY ${Python_VENV_SCRIPTS} # make sure scripts aren't run when from the same folder as mapscript.py
    DEPENDS mapscriptwheel.stamp
    OUTPUT mapscripttests.stamp
    COMMAND ${Python_VENV_SCRIPTS}/pip install --no-index --find-links=${OUTPUT_FOLDER}/dist mapscript
    # ERROR: file or package not found: mapscript.tests (missing __init__.py?) is caused by
    # ImportError: DLL load failed while importing _mapscript: The specified module could not be found.
    COMMAND ${Python_VENV_SCRIPTS}/python -m pytest --pyargs mapscript.tests
    COMMAND ${Python_VENV_SCRIPTS}/python -m mapscript.examples.project_csv ${PROJECT_SOURCE_DIR}/tests/cities.csv 2 1 EPSG:4326 EPSG:3857 > test.csv
    COMMAND ${Python_VENV_SCRIPTS}/python -m mapscript.examples.shpdump ${PROJECT_SOURCE_DIR}/tests/polygon.shp > shpdump.txt
    COMMAND ${Python_VENV_SCRIPTS}/python -m mapscript.examples.shpinfo ${PROJECT_SOURCE_DIR}/tests/polygon.shp > shpinfo.txt
    COMMAND ${Python_VENV_SCRIPTS}/python -m mapscript.examples.wxs ${PROJECT_SOURCE_DIR}/tests/test.map > response.xml
    COMMENT "Installing the Python wheel and testing it in the virtual environment, then running tests and examples"
)

add_custom_command(
    TARGET ${SWIG_MODULE_pythonmapscript_REAL_NAME}
    WORKING_DIRECTORY ${OUTPUT_FOLDER}
    POST_BUILD
    COMMAND ${CMAKE_COMMAND} -E copy "${PROJECT_SOURCE_DIR}/src/mapscript/python/mapscript/__init__.py" $<TARGET_FILE_DIR:${SWIG_MODULE_pythonmapscript_REAL_NAME}>/mapscript/__init__.py
    COMMAND ${CMAKE_COMMAND} -E copy "${CMAKE_CURRENT_BINARY_DIR}/mapscript.py" $<TARGET_FILE_DIR:${SWIG_MODULE_pythonmapscript_REAL_NAME}>/mapscript/mapscript.py
    COMMAND ${CMAKE_COMMAND} -E copy "$<TARGET_FILE:${SWIG_MODULE_pythonmapscript_REAL_NAME}>" "$<TARGET_FILE_DIR:${SWIG_MODULE_pythonmapscript_REAL_NAME}>/mapscript/$<TARGET_FILE_NAME:${SWIG_MODULE_pythonmapscript_REAL_NAME}>"
    COMMAND ${CMAKE_COMMAND} -E copy "${PROJECT_SOURCE_DIR}/src/mapscript/python/README.rst" $<TARGET_FILE_DIR:${SWIG_MODULE_pythonmapscript_REAL_NAME}>/README.rst
    COMMAND ${CMAKE_COMMAND} -E copy_directory "${PROJECT_SOURCE_DIR}/src/mapscript/python/tests/cases" $<TARGET_FILE_DIR:${SWIG_MODULE_pythonmapscript_REAL_NAME}>/mapscript/tests
    COMMAND ${CMAKE_COMMAND} -E copy_directory "${PROJECT_SOURCE_DIR}/tests" $<TARGET_FILE_DIR:${SWIG_MODULE_pythonmapscript_REAL_NAME}>/mapscript/tests/data
    COMMAND ${CMAKE_COMMAND} -E copy_directory "${PROJECT_SOURCE_DIR}/src/mapscript/python/examples" $<TARGET_FILE_DIR:${SWIG_MODULE_pythonmapscript_REAL_NAME}>/mapscript/examples
    COMMENT "Copying files required to build Mapscript"
)

install(
  CODE "
  
    SET(ENV{PYTHONPATH} \${Python_SITELIB}:\$ENV{PYTHONPATH})

    if(DEFINED ENV{DESTDIR})
      SET(PYTHON_ROOT \"--root=\$ENV{DESTDIR}\")
    endif()

    if(DEFINED CMAKE_INSTALL_PREFIX)
      SET(PYTHON_PREFIX \"--prefix=\${CMAKE_INSTALL_PREFIX}\")
    endif()

    execute_process(
      COMMAND ${Python_EXECUTABLE} -m pip install \${PYTHON_ROOT} \${PYTHON_PREFIX} .
      WORKING_DIRECTORY ${OUTPUT_FOLDER}
    )
  "
)

message(STATUS "CMake Version: ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}")
message(STATUS "Build Type: ${CMAKE_BUILD_TYPE}")
message(STATUS "Python MapScript output directory: ${OUTPUT_FOLDER}")
message(STATUS "Python Executable: ${Python_EXECUTABLE}")
message(STATUS "Python Version: ${Python_VERSION}")
message(STATUS "Python site packages: ${Python_SITELIB}")

=== debian/changelog ===
mapserver (8.2.1-1) unstable; urgency=high

  * New upstream release.
  * Update symbols for amd64.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 21 Jul 2024 20:03:16 +0200

=== debian/control ===
Source: mapserver
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Francesco Paolo Lovergine <frankie@debian.org>,
           Alan Boudreault <aboudreault@mapgears.com>,
           Bas Couwenberg <sebastic@debian.org>
Section: devel
Priority: optional
Build-Depends: ant,
               cmake (>= 3.0),
               chrpath,
               debhelper-compat (= 13),
               default-jdk,
               dh-php,
               dh-python,
               dh-sequence-pkgkde-symbolshelper,
               dh-sequence-python3,
               docbook2x,
               docbook-xsl,
               docbook-xml,
               dpkg-dev (>= 1.22.5),
               libcairo2-dev,
               libcurl4-gnutls-dev | libcurl-ssl-dev,
               libfcgi-dev,
               libfreetype-dev,
               libfribidi-dev,
               libgdal-dev (>= 1.10.1-0~),
               libgeos-dev (>= 3.3.1-1~),
               libgif-dev,
               libharfbuzz-dev,
               libjpeg-dev,
               libperl-dev,
               libpng-dev,
               libprotobuf-c-dev,
               libpq-dev,
               libproj-dev,
               librsvg2-dev,
               libxml2-dev,
               libxslt1-dev,
               php-dev,
               pkgconf,
               pkg-kde-tools,
               protobuf-c-compiler,
               python3,
               python3-dev,
               python3-pip,
               python3-setuptools,
               swig,
               xsltproc,
               zlib1g-dev (>= 1.1.4)
Build-Conflicts: libcurl3-openssl-dev
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/debian-gis-team/mapserver
Vcs-Git: https://salsa.debian.org/debian-gis-team/mapserver.git
Homepage: https://mapserver.org
Rules-Requires-Root: no

Package: libmapserver2t64
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: cgi-mapserver,
          mapserver-bin,
          mapserver-doc,
          libmapscript-perl,
          python3-mapscript
Pre-Depends: ${misc:Pre-Depends}
Provides: ${t64:Provides}
Breaks: libmapserver2 (<< ${source:Version})
Replaces: libmapserver2
Description: Shared library for MapServer
 This package contains the shared library.
 .
 MapServer is a CGI-based framework for Internet map services which
 supports Open Geospatial Consortium (OGC) standards. Scripting
 functionality in MapScript is provided by the suggested mapscript
 library packages.

Package: libmapserver-dev
Architecture: any
Section: libdevel
Depends: libmapserver2t64 (= ${binary:Version}),
         ${misc:Depends}
Suggests: cgi-mapserver,
          mapserver-bin,
          mapserver-doc,
          libmapscript-perl,
          php-mapscript-ng,
          python3-mapscript
Description: Shared library development files for MapServer
 This package contains the development files for the shared library.
 .
 MapServer is a CGI-based framework for Internet map services which
 supports Open Geospatial Consortium (OGC) standards. Scripting
 functionality in MapScript is provided by the suggested mapscript
 library packages.

Package: cgi-mapserver
Architecture: any
Section: web
Depends: mapserver-bin,
         ${misc:Depends}
Suggests: mapserver-doc,
          libmapscript-perl,
          php-mapscript-ng,
          python3-mapscript
Description: CGI executable for MapServer
 This package contains the mapserv CGI program. It provides the
 MapServer template language, and can be used to implement Web Map
 Service applications.
 .
 MapServer is a CGI-based framework for Internet map services which
 supports Open Geospatial Consortium (OGC) standards. Scripting
 functionality in MapScript is provided by the suggested mapscript
 library packages.

Package: mapserver-bin
Architecture: any
Section: misc
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: cgi-mapserver,
          mapserver-doc,
          shapelib,
          libmapscript-perl,
          php-mapscript-ng,
          python3-mapscript
Breaks: libmapserver-dev (<< 8.0.0-2~)
Replaces: libmapserver-dev (<< 8.0.0-2~)
Description: MapServer utilities
 This package provides command-line utilities for MapServer.
 .
 MapServer is a CGI-based framework for Internet map services which
 supports Open Geospatial Consortium (OGC) standards. Scripting
 functionality in MapScript is provided by the suggested mapscript
 library packages.

Package: mapserver-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Suggests: cgi-mapserver,
          libmapscript-perl,
          php-mapscript-ng,
          python3-mapscript
Description: documentation for MapServer
 This package provides some brief documentation for MapServer.
 .
 MapServer is a CGI-based framework for Internet map services which
 supports Open Geospatial Consortium (OGC) standards. Scripting
 functionality in MapScript is provided by the suggested mapscript
 library packages.

Package: php-mapscript-ng
Architecture: any
Section: php
Depends: ${php:Depends},
         ${shlibs:Depends},
         ${misc:Depends}
Suggests: mapserver-bin,
          mapserver-doc
Description: PHP MapServer module (SWIG)
 PHP MapScript provides MapServer functions for PHP scripts.
 .
 MapServer is a CGI-based framework for Internet map services which
 supports Open Geospatial Consortium (OGC) standards.
 .
 This package provides MapScript for PHP based on SWIG.

Package: libmapscript-perl
Architecture: any
Section: perl
Depends: ${perl:Depends},
         ${shlibs:Depends},
         ${misc:Depends}
Suggests: mapserver-bin,
          mapserver-doc
Conflicts: perl-mapscript
Provides: perl-mapscript
Replaces: perl-mapscript
Description: Perl MapServer module
 Perl MapScript module provides MapServer functions for Perl scripts.
 .
 MapServer is a CGI-based framework for Internet map services which
 supports Open Geospatial Consortium (OGC) standards.

Package: python3-mapscript
Architecture: any
Section: python
Depends: ${python3:Depends},
         ${shlibs:Depends},
         ${misc:Depends}
Suggests: mapserver-bin,
          mapserver-doc
Description: Python library for MapServer
 Python MapScript provides MapServer functions for Python scripts.
 .
 MapServer is a CGI-based framework for Internet map services which
 supports Open Geospatial Consortium (OGC) standards.

Package: libmapscript-java
Architecture: any
Section: java
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: mapserver-bin,
          mapserver-doc
Description: Java library for MapServer
 Java MapScript provides MapServer functions for Java applications.
 .
 MapServer is a CGI-based framework for Internet map services which
 supports Open Geospatial Consortium (OGC) standards.

## mapserver 8.2.2

=== debian/changelog ===
mapserver (8.2.2-1build2) plucky; urgency=medium

  * No-change rebuild for Python 3.13 as the default.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 04 Jan 2025 05:18:54 +0100

mapserver (8.2.2-1build1) plucky; urgency=medium

  * No-change rebuild for libgdal36.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Tue, 31 Dec 2024 23:54:22 +0000

mapserver (8.2.2-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.7.0, no changes.
  * Update symbols for other architectures.
  * Update lintian overrides.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 02 Sep 2024 18:41:33 +0200

=== debian/control ===
--- 
+++ 
@@ -48,7 +48,7 @@
                xsltproc,
                zlib1g-dev (>= 1.1.4)
 Build-Conflicts: libcurl3-openssl-dev
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/debian-gis-team/mapserver
 Vcs-Git: https://salsa.debian.org/debian-gis-team/mapserver.git
 Homepage: https://mapserver.org

## mapserver 8.4.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.0...3.29)
+cmake_minimum_required(VERSION 3.16...3.29)
 
 project (MapServer)
 
@@ -16,8 +16,8 @@
 include(CheckCSourceCompiles)
 
 set (MapServer_VERSION_MAJOR 8)
-set (MapServer_VERSION_MINOR 2)
-set (MapServer_VERSION_REVISION 1)
+set (MapServer_VERSION_MINOR 4)
+set (MapServer_VERSION_REVISION 0)
 set (MapServer_VERSION_SUFFIX "")
 
 # Set C++ version
@@ -29,10 +29,10 @@
 set(CMAKE_CXX_EXTENSIONS OFF)
 message(STATUS "Requiring C++${CMAKE_CXX_STANDARD} - done")
 
-# Set C99 version
+# Set C version
 # Make CMAKE_C_STANDARD available as cache option overridable by user
-set(CMAKE_C_STANDARD 99
-  CACHE STRING "C standard version to use (default is 99)")
+set(CMAKE_C_STANDARD 11
+  CACHE STRING "C standard version to use (default is 11)")
 message(STATUS "Requiring C${CMAKE_C_STANDARD}")
 set(CMAKE_C_STANDARD_REQUIRED ON)
 set(CMAKE_C_EXTENSIONS OFF)
@@ -82,10 +82,10 @@
 
 macro (ms_link_libraries)
   if(BUILD_DYNAMIC)
-    target_link_libraries(mapserver ${ARGV})
+    target_link_libraries(mapserver PRIVATE ${ARGV})
   endif(BUILD_DYNAMIC)
   if(BUILD_STATIC)
-    target_link_libraries(mapserver_static ${ARGV})
+    target_link_libraries(mapserver_static PRIVATE ${ARGV})
   endif(BUILD_STATIC)
 endmacro()
 
@@ -147,12 +147,12 @@
 
 include_directories(${CMAKE_CURRENT_BINARY_DIR})
 
-#options suported by the cmake builder
+#options supported by the cmake builder
 option(WITH_PROTOBUFC "Choose if protocol buffers support should be built in (required for vector tiles)" ON)
 option(WITH_KML "Enable native KML output support (requires libxml2 support)" OFF)
 option(WITH_SOS "Enable SOS Server support (requires PROJ and libxml2 support)" OFF)
 option(WITH_WMS "Enable WMS Server support (requires PROJ support)" ON)
-option(WITH_FRIBIDI "Choose if FriBidi glyph shaping support should be built in (usefull for right-to-left languages) (requires HARFBUZZ)" ON)
+option(WITH_FRIBIDI "Choose if FriBidi glyph shaping support should be built in (useful for right-to-left languages) (requires HARFBUZZ)" ON)
 option(WITH_HARFBUZZ "Choose if Harfbuzz complex text layout should be included (needed for e.g. arabic and hindi) (requires FRIBIDI)" ON)
 option(WITH_ICONV "Choose if Iconv Internationalization support should be built in" ON)
 option(WITH_CAIRO "Choose if CAIRO  rendering support should be built in (required for SVG and PDF output)" ON)
@@ -182,7 +182,7 @@
 option(WITH_MSSQL2008 "include mssql 2008 database input support as plugin" OFF)
 option(WITH_EXEMPI "include xmp output metadata support" OFF)
 option(WITH_XMLMAPFILE "include native xml mapfile support (requires libxslt/libexslt)" OFF)
-option(WITH_V8 "include javacript v8 scripting" OFF)
+option(WITH_V8 "include javascript v8 scripting" OFF)
 option(WITH_PIXMAN "use (experimental) support for pixman for layer compositing operations" OFF)
 
 option(BUILD_STATIC "Also build a static version of mapserver" OFF)

=== src/mapscript/phpng/CMakeLists.txt ===
find_package(SWIG REQUIRED)
include(${SWIG_USE_FILE})

if(WIN32)
  FIND_PACKAGE(SWIG 3.0.11 REQUIRED)
  if(WITH_THREAD_SAFETY)
    FIND_PACKAGE(SWIG 4.0.0 REQUIRED)
  endif(WITH_THREAD_SAFETY)
endif(WIN32)

FIND_PACKAGE(PHP REQUIRED)
INCLUDE(UseSWIG)

if(WIN32)
  add_definitions(/DWIN32 /DZEND_WIN32 /DPHP_WIN32 /DZEND_DEBUG=0)
  if(NOT CMAKE_CL_64)
    add_definitions(-D_USE_32BIT_TIME_T)
  endif(NOT CMAKE_CL_64)
  if(WITH_THREAD_SAFETY)
    add_definitions(-DZTS=1)
  endif(WITH_THREAD_SAFETY)
endif(WIN32)

include_directories(${PHP_INCLUDE_PATH})
message(STATUS "PHP Include Path: ${PHP_INCLUDE_PATH}")

include_directories(${PROJECT_SOURCE_DIR}/src/mapscript/swiginc)
include_directories(${PROJECT_SOURCE_DIR}/src/mapscript/)
include_directories(${PROJECT_SOURCE_DIR}/src/mapscript/phpng)
include_directories(${PROJECT_BINARY_DIR}/src/mapscript/)
include_directories(${CMAKE_CURRENT_BINARY_DIR}) # make sure mapscriptPHP7_wrap.c is found

if(WIN32)
  include_directories(${PHP_INCLUDE_PATH}/win32)
endif(WIN32)

IF(PHP_VERSION LESS 5)
  MESSAGE(FATAL_ERROR "PHP version is not 5 or later")
ENDIF(PHP_VERSION LESS 5)

IF(PHP_VERSION LESS 7)
  if (${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION} VERSION_GREATER 3.7)
      SWIG_ADD_LIBRARY(php_mapscriptng TYPE MODULE LANGUAGE php SOURCES ../mapscript.i)
  else ()
      swig_add_module(php_mapscriptng php ../mapscript.i)
  endif ()
ELSE()
  if (${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION} VERSION_GREATER 3.7)
      SWIG_ADD_LIBRARY(php_mapscriptng TYPE MODULE LANGUAGE php7 SOURCES ../mapscript.i)
  else ()
      swig_add_module(php_mapscriptng php7 ../mapscript.i)
  endif ()
ENDIF(PHP_VERSION LESS 7)

if(WIN32)
  target_compile_options(php_mapscriptng PRIVATE /DWIN32 /DZEND_WIN32 /DPHP_WIN32 /DZEND_DEBUG=0)
  if(WITH_THREAD_SAFETY)
    target_compile_options(php_mapscriptng PRIVATE /DZTS=1)
  endif(WITH_THREAD_SAFETY)
  SWIG_LINK_LIBRARIES(php_mapscriptng ${PHP_LIBRARY})
endif(WIN32)

IF(APPLE)
  if(XCODE)
     SET(CMAKE_C_LINK_FLAGS
        "${CMAKE_C_LINK_FLAGS} -undefined dynamic_lookup")
     SET(CMAKE_CXX_LINK_FLAGS
        "${CMAKE_CXX_LINK_FLAGS} -undefined dynamic_lookup")
  else(XCODE)
     SET(CMAKE_SHARED_MODULE_CREATE_C_FLAGS
        "${CMAKE_SHARED_MODULE_CREATE_C_FLAGS} -undefined dynamic_lookup")
     SET(CMAKE_SHARED_MODULE_CREATE_CXX_FLAGS
        "${CMAKE_SHARED_MODULE_CREATE_CXX_FLAGS} -undefined dynamic_lookup")
  endif(XCODE)
ENDIF(APPLE)

# hide "defined but not used" warnings
target_compile_options(php_mapscriptng PRIVATE -Wno-unused-label)

target_link_libraries(php_mapscriptng mapserver)
set_target_properties(${SWIG_MODULE_mapscript_REAL_NAME} PROPERTIES PREFIX "")

if(NOT WIN32)
  install(TARGETS php_mapscriptng DESTINATION ${PHP_EXTENSION_DIR})
  # check if we must install the required file containing MapServer constants and functions
  if(${SWIG_VERSION} LESS_EQUAL 4.0.2)
     install(FILES ${CMAKE_CURRENT_BINARY_DIR}/mapscript.php DESTINATION ${PHP_EXTENSION_DIR} COMPONENT dev)
  endif()
endif()

=== debian/changelog ===
mapserver (8.4.0-4+deb13u1) trixie; urgency=medium

  * Update branch in gbp.conf & Vcs-Git URL.
  * Add upstream patch to fix CVE-2025-59431.
  * Update symbols for msStringUnescape.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 21 Sep 2025 15:31:40 -0700

mapserver (8.4.0-4) unstable; urgency=medium

  * Re-enable FCGI support.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 02 Apr 2025 16:57:32 +0200

mapserver (8.4.0-3) unstable; urgency=medium

  * Disable FCGI support. Has problematic license, see: #466117.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 01 Apr 2025 21:30:34 +0200

mapserver (8.4.0-2) unstable; urgency=medium

  * Bump Standards-Version to 4.7.2, no changes.
  * Add patch to fix FTBFS with ICU 76.
    (closes: #1101239)

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 26 Mar 2025 05:40:48 +0100

mapserver (8.4.0-1) unstable; urgency=medium

  * New upstream release.
  * Strip pre-releases from symbols version.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 15 Jan 2025 15:51:45 +0100

mapserver (8.4.0~rc1-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Update copyright file.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 08 Jan 2025 17:12:31 +0100

mapserver (8.4.0~beta2-1~exp1) experimental; urgency=medium

  * New upstream beta release.
  * Update symbols for other architectures.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 14 Dec 2024 15:23:47 +0100

mapserver (8.4.0~beta1-1~exp1) experimental; urgency=medium

  * New upstream beta release.
  * Update copyright file.
  * Update symbols for amd64.
  * Update lintian overrides.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 13 Dec 2024 14:45:13 +0100

=== debian/control ===
--- 
+++ 
@@ -48,9 +48,9 @@
                xsltproc,
                zlib1g-dev (>= 1.1.4)
 Build-Conflicts: libcurl3-openssl-dev
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/debian-gis-team/mapserver
-Vcs-Git: https://salsa.debian.org/debian-gis-team/mapserver.git
+Vcs-Git: https://salsa.debian.org/debian-gis-team/mapserver.git -b trixie
 Homepage: https://mapserver.org
 Rules-Requires-Root: no

=== debian/watch ===
version=4
opts=\
dversionmangle=s/\+(debian|dfsg|ds|deb)\d*$//,\
uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/;s/RC/rc/;s/-/./g \
https://download.osgeo.org/mapserver/ \
(?:.*/)?(?:rel|v|mapserver)[\-\_]?(\d\S+)\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
